package eu.eudat.integrationevent.outbox.descriptiontouched;

import eu.eudat.commons.enums.DescriptionStatus;
import eu.eudat.integrationevent.TrackedEvent;
import eu.eudat.model.persist.descriptionproperties.PropertyDefinitionPersist;

import java.util.List;
import java.util.UUID;

public class DescriptionTouchedIntegrationEvent extends TrackedEvent {

    private UUID id;

    private String label;

    private UUID dmpId;

    private UUID dmpDescriptionTemplateId;

    private UUID descriptionTemplateId;

    private DescriptionStatus status;

    private String description;

    private PropertyDefinitionPersist properties;

    private List<String> tags;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public UUID getDmpId() {
        return dmpId;
    }

    public void setDmpId(UUID dmpId) {
        this.dmpId = dmpId;
    }

    public UUID getDmpDescriptionTemplateId() {
        return dmpDescriptionTemplateId;
    }

    public void setDmpDescriptionTemplateId(UUID dmpDescriptionTemplateId) {
        this.dmpDescriptionTemplateId = dmpDescriptionTemplateId;
    }

    public UUID getDescriptionTemplateId() {
        return descriptionTemplateId;
    }

    public void setDescriptionTemplateId(UUID descriptionTemplateId) {
        this.descriptionTemplateId = descriptionTemplateId;
    }

    public DescriptionStatus getStatus() {
        return status;
    }

    public void setStatus(DescriptionStatus status) {
        this.status = status;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public PropertyDefinitionPersist getProperties() {
        return properties;
    }

    public void setProperties(PropertyDefinitionPersist properties) {
        this.properties = properties;
    }

    public List<String> getTags() {
        return tags;
    }

    public void setTags(List<String> tags) {
        this.tags = tags;
    }

}
