import { Lookup } from "@common/model/lookup";
import { Guid } from "@common/types/guid";
import { LockTargetType } from "../common/enum/lock-target-type";

export class LockLookup extends Lookup implements LockLookup {
	ids: Guid[];
	excludedIds: Guid[];
    targetIds: Guid[];
	targetTypes: LockTargetType[];

	constructor() {
		super();
	}
}

export interface LockLookup {
	ids: Guid[];
	excludedIds: Guid[];
    targetIds: Guid[];
	targetTypes: LockTargetType[];
}