package eu.eudat.controllers.old;

import eu.eudat.logic.managers.LocalFetchManager;
import eu.eudat.models.old.local.LocalFetchModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@CrossOrigin
@RequestMapping(value = "api/currency")
public class CurrencyController {

	private LocalFetchManager localFetchManager;

	@Autowired
	public CurrencyController(LocalFetchManager localFetchManager) {
		this.localFetchManager = localFetchManager;
	}

	@RequestMapping(method = RequestMethod.GET)
	public List<LocalFetchModel> getCurrencies( @RequestParam(value = "query", required = false) String query) throws Exception {
		List<LocalFetchModel> currencies = localFetchManager.getCurrency(query);
		return currencies;
	}
}
